declare('frames', {})

function frames.BuildDialog()
	local function fill(name)
		return iup.vbox{iup.label{title=name},iup.fill{size=50},iup.hbox{iup.fill{size=200}}}
	end
	
	local frames = iup.vbox{
		-- Frames
		iup.frame{ fill('frame'), expand="NO" },

		iup.pdarootframe{ fill('pdarootframe'), expand="NO" },
		iup.pdarootframebg{ fill('pdarootframebg'), expand="NO" },
		iup.pdasubframe_nomargin{ fill('pdasubframe_nomargin'), expand="NO" },
		iup.pdasubframebg{ fill('pdasubframebg'), expand="NO" },
		iup.pdasubsubframebg{ fill('pdasubsubframebg'), expand="NO" },
		iup.pdasubsubsubframe2{ fill('pdasubsubsubframe2'), expand="NO" },
		iup.pdasubsubsubframebg{ fill('pdasubsubsubframebg'), expand="NO" },
		iup.pdasubsubsubframefull2{ fill('pdasubsubsubframefull2'), expand="NO" },

		iup.hudchatframe{ fill('hudchatframe'), expand="NO" },
		iup.hudleftframe{ fill('hudleftframe'), expand="NO" },
		iup.hudrightframe{ fill('hudrightframe'), expand="NO" },
		iup.hudchatframe_old{ fill('hudchatframe_old'), expand="NO" },
		iup.hudleftframe_old{ fill('hudleftframe_old'), expand="NO" },
		iup.hudrightframe_old{ fill('hudrightframe_old'), expand="NO" },

		iup.stationmainframe{ fill('stationmainframe'), expand="NO" },
		iup.stationmainframebg{ fill('stationmainframebg'), expand="NO" },
		iup.stationnameframe{ fill('stationnameframe'), expand="NO" },
		iup.stationdoubleframe{ fill('stationdoubleframe'), expand="NO" },
		iup.stationbuttonframe{ fill('stationbuttonframe'), expand="NO" },
		iup.stationhighopacityframe{ fill('stationhighopacityframe'), expand="NO" },
		iup.stationhighopacityframebg{ fill('stationhighopacityframebg'), expand="NO" },
		iup.stationhighopacityframebgfiller{ fill('stationhighopacityframebgfiller'), expand="NO" },

		iup.stationsubframe{ fill('stationsubframe'), expand="NO" },
		iup.stationsubframebg{ fill('stationsubframebg'), expand="NO" },
		iup.stationsubframebgfiller{ fill('stationsubframebgfiller'), expand="NO" },
		iup.stationsubframe_nomargin{ fill('stationsubframe_nomargin'), expand="NO" },
		iup.stationsubhollowframe{ fill('stationsubhollowframe'), expand="NO" },
		iup.stationhighopacitysubframe{ fill('stationhighopacitysubframe'), expand="NO" },
		iup.stationsubframevdivider{ fill('stationsubframevdivider'), size = 20, },
		iup.stationsubframehdivider{ fill('stationsubframehdivider'), size = 20, },

		iup.stationsubsubframe{ fill('stationsubsubframe'), expand="NO" },
		iup.stationsubsubframebg{ fill('stationsubsubframebg'), expand="NO" },
		iup.stationsubsubframe2{ fill('stationsubsubframe2'), expand="NO" },
		iup.stationsubsubframevdivider{ fill('stationsubsubframevdivier'), size = 20, },
		iup.stationsubsubframehdivider{ fill('stationsubsubhframedivider'), size = 20, },
		
		-- Listboxes
		iup.pdarootlist{'pdarootlist', size = "200x50"},

		iup.pdasublist{'pdasublist', size = "200x50"},
		iup.pdasubsublist{'pdasubsublist', size = "200x50"},
		iup.pdasubsubsublist{'pdasubsubsublist', size = "200x50"},

		iup.stationsublist{'stationsublist', size = "200x50"},
		iup.stationsubsublist{'stationsubsublist', size = "200x50"},

		iup.stationhighopacitysublist{'stationhighopacitysublist', size = "200x50"},
		gap = 10,
	}

	local closebutton = iup.stationbutton{title = "Close", size = "1x1", action = function(self) HideDialog(iup.GetDialog(self)) end, visible = "NO"}

	local function subdlg(ctrl) return iup.dialog{ctrl,border="NO",menubox="NO",resize="NO",bgcolor="0 0 0 0 *",} end

	local list = iup.stationsublist{expand = "YES", control = "YES", border = "NO", bgcolor = "0 0 0 0 *"}
	iup.Append(list, subdlg(frames))
	list:map()
	list[1] = 1
	
	local dlg = iup.dialog{
		iup.vbox{list, closebutton},
		defaultesc = closebutton,
		topmost = "YES",
		fullscreen = "NO",
		bgcolor = "0 0 0 0 *",
		size = HUDSize(.33,.75),
	}
	dlg:map()
	return dlg
end

frames.dlg = frames.BuildDialog()

RegisterUserCommand('viewframes', function() ShowDialog(frames.dlg) end)

